private import all;

class Course: TaskObject {
	mixin GROUP!(GROUP_BG);

	private timer.Timer tim;
	this() {
		move = &move1;
		draw = &draw1;
		name = "c1.pdr";
		navi = getNavi(name);
		data = makeLines(pdrs[name]);
		data2 = connect(data);
		tim = new Timer();
		tim.setShip(&Ship.ship);
	}
	~this() {
//		delete tim;
	}
	static float[][] navi;
	void move1() {
		Ship.ship().y =  -580000;
//		Ship.ship().y =  580000;
//		Ship.ship().direction =  90;
		move = &move2;
	}
	void move2() {}
	void drawTree(float x, float z) {
		glPushMatrix();
		glRotatef(-90, 1, 0,  0);
		glTranslatef(x*200, -30000, z*200);
		glScalef(10, 10, 10);
		pdr.draw("tree1.pdr");
		glRotatef(-90, 0, 1,  0);
		pdr.draw("tree1.pdr");
		glPopMatrix();
	
	}
	void draw1() {
		glPushMatrix();
		glScalef(200, 200, 200);
//		glTranslatef(x, y, z);
//		glRotatef(direction, rotateX, rotateY,  rotateZ);
		pdr.draw(name);
		glPopMatrix();
		for (int i = 1; i < data2.length; i+=6) {
			float[][] dt2 = data2[i];
			drawTree(dt2[0][0],dt2[0][1]);
		}
		for (int i = 4; i < data2.length; i+=6) {
			float[][] dt2 = data2[i];
			drawTree(dt2[1][0],dt2[1][1]);
		}

	}
	static char[] name;
	static float[][][] data;
	static float[][][] data2;
	static int check(float x, float y) {
//		return pdr.check("c1.pdr", 0,0);
//		throw new Error("error");
		return check2(data, x/200.0,y/200.0);
	}
	static void checkNo(int no, float x, float y, inout float px, inout float py, out float px2, out float py2) {
//		return pdrcheck("c1.pdr", 0,0);
//		throw new Error("error");
		px = px / 200.0; py = py / 200.0;
		checkNo2(data2, no, x/200.0,y/200.0, px, py, px2, py2);
		px = px * 200.0; py = py * 200.0;
		px2 = px2 * 200.0; py2 = py2 * 200.0;
	}

/**
 * 見つかれば、その番号
 * 見つからなければ、0を返す。
 */
static int check2(float[][][] dt, float x, float y) {
	for (int i = 0; i < dt.length; i++) {
		float[][] dt2 = dt[i];
		int j;
		for (j = 0; j < dt2.length; j++) {// 交差判定を始める。
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			V v3 = V(x,y);
			float s = (v2-v1) * (v3-v1);
			if (s < 0) break;
		}
		if (j == dt2.length) return i+1;
	}
	return 0;
}
static void checkNo2(float[][][] dt, int no, float x, float y, inout float px, inout float py, inout float px2, inout float py2) {
//	float[][] dt2 = dt[no-1];
//		printf("checkNo %d\n", no);
	for (int i = 0; i < dt.length; i++) {
		float[][] dt2 = dt[i];
//	do {
		for (int j = 0; j < dt2.length; j++) {
			// 交差判定を始める。
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			V v3 = V(x,  y);
			V v4 = V(px,py);
	//		printf("%4.0f %4.0f %4.0f %4.0f %4.0f %4.0f %4.0f %4.0f\n", v1.x, v1.y, v2.x, v2.y, v3.x, v3.y, v4.x, v4.y);
			if (is_intersected_ls(v1,v2,v3,v4)) {// 交差してる。
				V v5 = intersection_l(v1,v2,v3,v4);// 交点を求める。
				V na = (v1 - v2).normalize()*15;
				V n = V(na.y, -na.x);// 法線
				V v6 = v5 + n;
				if(check2(Course.data,v6.x,v6.y)==0){// 横に移動する。
					// 角付近のはずなので、近い角を探す。
					if((v5 - v1).abs()<(v5-v2).abs()){
						// v1から遠い
						na = na * -1;
					}
					for (int k = 0; k <5 && check2(Course.data,v6.x,v6.y)==0; k++){// 横に移動する。
						v6 = v6 + na;
					}
				}
				px2 = px = v6.x; py2 = py = v6.y;// 交点
				return;
	/*
				V l = v5 - v3;
				if (n * l > 0) n = n * -1;
				if (n * l <= 0) l = l * -1;
				V ld = 2 * n * (l^n) - l;
				// Ｌ’＝２×Ｎ×（Ｌ・Ｎ）－Ｌ
				ld = ld + v5;
				px2 = ld.x; py2 = ld.y;// 跳ね返る方向。*/
				
		px2 = px = x;
		py2 = py = y;
				return;
			}
		}
	}
//		dt2 = dt[i++];
//	} while(i <= dt.length);
	printf("dame ck x  %d %4.0f %4.0f\n",check2(Course.data, x,  y), x, y);
	printf("dame ck px %d %4.0f %4.0f\n",check2(Course.data, px, py), px, py);
//		printf("%4.0f %4.0f %4.0f %4.0f\n", x, y, px, py);
	px2 = px = x;
	py2 = py = y;
}
// 点a,bを端点とする線分と点cとの距離
static double distance_ls_p(V a, V b, V c) {
	const float EPS = 0.0001;
	if ( ((b-a) ^ (c-a)) < EPS ) return (c-a).abs();
	if ( ((a-b) ^ (c-b)) < EPS ) return (c-b).abs();
	return std.math.abs((b-a)*(c-a)) / (b-a).abs();
}

// a1,a2を端点とする線分とb1,b2を端点とする線分の交差判定
static bool is_intersected_ls(inout V a1, inout V a2, inout V b1, inout V b2) {
	const float EPS = 0.00001;
	return ( ((a2-a1) * (b1-a1)) * ((a2-a1) * (b2-a1)) <= EPS ) &&
	       ( ((b2-b1) * (a1-b1)) * ((b2-b1) * (a2-b1)) <= EPS );
}

// a1,a2を端点とする線分とb1,b2を端点とする線分の交点計算
static V intersection_ls(inout V a1, inout V a2, inout V b1, inout V b2) {
  V b = b2-b1;
  float d1 = std.math.abs(b * (a1 - b1));
  float d2 = std.math.abs(b * (a2 - b1));
  float t = d1 / (d1 + d2);

  return a1 + (a2-a1) * t;
}

// a1,a2を通る直線とb1,b2を通る直線の交点計算
static V intersection_l(inout V a1, inout V a2, inout V b1, inout V b2) {
	V a = a2 - a1; V b = b2 - b1;
	float f = ((b * (b1-a1))/(b*a));
	return a1 + a * f;
}


// くっつける処理。
static float[][][] connect(float[][][] ps) {
	float[][][] rc = ps.dup;
	for (int i = 0; i < rc.length; i++) {
		float[][] dt2 = rc[i];
		for (int j = 0; j < dt2.length; j++) {
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			// で、同じ線を探して消す。
			removeLine(rc,i+1,v1,v2);
		}
	}
	return rc;
}

// 同じ線があったら消す。
static void removeLine(inout float[][][] ps, int start, inout V a1, inout V a2) {
	for (int i = start; i < ps.length; i++) {
		float[][] dt2 = ps[i];
		float[][] dt3;
		for (int j = 0; j < dt2.length; j++) {
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			if (a1.x==v2.x&&a1.y==v2.y && a2.x==v1.x&&a2.y==v1.y) {
				continue;
			}
			dt3 ~= dt2[j];
		}
		ps[i] = dt3;
	}
}

static float[][][] makeLines(inout float[][] ps) {
	float[][][] r;
	for (int i = 0; i < ps.length; i++) {
		float[] dt2 = ps[i];
		float[][] dt3;
		for (int j = 8; j < dt2.length; j+=3) {
			int n1 = j + 3;
			if (n1 == dt2.length) n1 = 8;
			dt3 ~= [dt2[j..j+3] ~ dt2[n1..n1+3]];
		}
		r ~= dt3;
	}
	return r;
}

/+

// ①隣のポリゴンを探す。
// ②あったら、角の角度を求める。
// ③角度が90度より大きかったら、削る。
// 削る方法は、角度により削る長さを求める。
// 削る辺の長さを求め、削る長さをひいた分の点を削った点にする。
// 片方のポリゴンに相手方の削られた頂点位置を追加する。
// 削る長さは 飛ばす長さ/削る長さ=sin(θ)になる。
// 削る長さ = 飛ばす長さ/sin(θ)
// となる。ところで、axb = |a||b| sinθである。
// 削る長さ = 飛ばす長さ/abs(単位ベクトルの外積)
// である。ぴったりだと恐いので、ちょっと多めにしておこう。
// では実装。
// 角を削る処理。
static float[][][] cutCorner(float[][][] ps) {
	float[][][] rc = ps.dup;
	for (int i = 0; i < rc.length; i++) {
		float[][] dt2 = rc[i];
		for (int j = 0; j < dt2.length; j++) {
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			// で、同じ線を探して場合によって削る。
			cutFindCorner(rc,i, j,v1,v2);
		}
	}
	return rc;
}

// 同じ線を探して場合によって削る。
static void cutFindCorner(inout float[][][] ps, int s1, int s2, inout V a1, inout V a2) {
	for (int i = s1+1; i < ps.length; i++) {
		float[][] dt2 = ps[i];
		float[][] dt3;
		for (int j = 0; j < dt2.length; j++) {
			V v1 = V(dt2[j][0],dt2[j][1]);
			V v2 = V(dt2[j][3],dt2[j][4]);
			if (a1.x==v2.x&&a1.y==v2.y && a2.x==v1.x&&a2.y==v1.y) {
				// 同じ線を見つけた。
				// 角を取るのだけど、取るために必要な情報を得る。
				// ３つのベクトルから角を取る場合２つのベクトルを得る。
				float[] p1n = dt2[(j  +     1) % $];// 
				float[] p2n = ps[s1][(s2 + $ - 1) % $];
				float[] cut1 = cutCorner2(ps, a1.x, a1.y, p1n[0], p1n[1], p2n[2], p2n[3]);
				float[] p3n = dt2[(j  + $ - 1) % $];
				float[] p4n = ps[s1][(s2 + 1) % $];
				float[] cut2 = cutCorner2(ps, a2.x, a2.y, p3n[2], p3n[3], p4n[0], p4n[1]);
				// 片方のポリゴンに相手方の削られた頂点位置を追加すればよい。
				// うーと、相手方のポリゴンを変更して、自分も変更した後追加すると。
				// 追加する点はちょうど

				continue;
			}
			dt3 ~= dt2[j];
		}
		ps[i] = dt3;
	}
}

// ②あったら、角の角度を求める。
// 
// ③角度が90度より大きかったら、削る。
// 削る方法は、角度により削る長さを求める。
// 削る辺の長さを求め、削る長さをひいた分の点を削った点にする。
// 片方のポリゴンに相手方の削られた頂点位置を追加する。
// 削る長さは 飛ばす長さ/削る長さ=sin(θ)になる。
// 削る長さ = 飛ばす長さ/sin(θ)
// となる。ところで、axb = |a||b| sinθである。
// 削る長さ = 飛ばす長さ/abs(単位ベクトルの外積)
// である。ぴったりだと恐いので、ちょっと多めにしておこう。
// では実装。
+/
	static float[][][char[]] navis;
	static float[][] getNavi(char[] name) {
		if (name in navis) return navis[name];
		float[][] ps = pdrs[name];
		for(int i = 0; i < ps.length; i++) {
			float[] dt2 = ps[i];
			if (dt2[3]<=0.01){// && dt2[0]>=0.99 && dt2[1]<=0.01 && dt2[2]<=0.01) {
				printf("ok");
//				pdrs[name] = ps[0..i] ~ ps[i+1..$];
				float[][] dt3 = [dt2];
				return navis[name] = makeLines(dt3)[0];
			}
		}
		return null;
	}
	static int getRank(float x, float y) {
		x = x / 200.0;
		y = y / 200.0;
		float min = float.max;
		int no = 0;
		for (int i = 0; i < navi.length; i++) {
			float[] d = navi[i];
			float v = (d[0]-x)*(d[0]-x)+(d[1]-y)*(d[1]-y);
			if (min > v) {min=v;no = i;}
		}
//番号は、一番近くの点とする。
//で、その点から、入っている領域の番号を求める。
//そして、その点から２つの長さ１のベクトルを作って
//そこからの距離を求める。
//その距離が近いほうが、その領域。
		float[] f0 = navi[(no - 1 + $) % $];
		float[] f1 = navi[ no             ];
		float[] f2 = navi[(no + 1    ) % $];
		V a  = V(x,y);
		V v0 = V(f0[0],f0[1]);
		V v1 = V(f1[0],f1[1]);
		V v2 = V(f2[0],f2[1]);
		V n0 = (v0-v1).normalize();
		V n2 = (v2-v1).normalize();
		if ( (a-(n0+v1)).abs() < (a-(n2+v1)).abs() ) {
			// n0が近い。
			// 番号を１つ戻す。
			no = (no - 1 + navi.length) % navi.length;
			// 媒介変数表示するんだけど、どうやってやったらいい？
			// え？
			V n = V(n0.y, -n0.x);
			float a1 = (a-v1)*(n);
			// だ。これが長さだ。
			float no1 = a1 / (v1 - v0).abs();
//			printf("%08.8f\n",no1);
			no = no * 10000 +8000+ cast(int)(no1*100);
		} else {
			V n = V(-n2.y, n2.x);
			float a1 = (a-v1)*(n);
			// だ。これが長さだ。
//		printf("%f %f %f\n", a1,v1.x,v1.y);
			float no1 = a1 / (v2 - v1).abs();
//			printf("%08.8f\n",no1);
			no = no * 10000 +3000+ cast(int)(no1*100);
			// n2が近い。
		}
		return no;
	}

}
