private import all;
private import std.c.stdio;

class Timer : TaskObject {
	mixin GROUP!(GROUP_TEXT);

	bool reverseFlag;
	int[5] lapTimes;
	int lap;
	int pos;
	int oldpos;
	int lapTime;
	int allTime;
	int baseTime;
	int fastestTime;
	Ship function() ship;
	void setShip(Ship function() s) { this.ship = s; }
	this() {
		reverseFlag = false;
		lap = 0;
		move = &move1;
		pos = int.max;
		lapTime = 0;
		allTime = 0;
		baseTime = 0;
		draw = &draw1;
		fastestTime = 99*60*60*100 + 59*60*100+59*100+99;
	}
	void move1() {
		oldpos = pos;
		pos = ship().pos;
		if (pos < 10000 && oldpos > (Course.navi.length-2)*10000) {
			if (reverseFlag) reverseFlag = false;
			else {
				if (lap != 0) {
					lapTimes[lap % $] = lapTime;
					if (fastestTime > lapTime) fastestTime = lapTime;
				}
				lapTime = 0;
				lap++;
			}
		} else
		if (oldpos < 10000 && pos > (Course.navi.length-2)*10000) {
			reverseFlag = true;
		}
		lapTime++;
		allTime++;
		baseTime++;
		if (baseTime % 3 == 0){lapTime++;allTime++;}
//		printf("%8d %8d %8d %8d %d\n", pos,lapTime, allTime, lap, reverseFlag);
	}
	static void drawScore(int t) {
		scope char[8+1] s;
		scope char[] ss = s[0..8];
		sprintf(cast(char*)s, cast(char*)"%02d:%02d:%02d", t/(60*100) % 60,t/100 % 60, (t % 100));util_ascii.draw(ss);
		glTranslatef(0, 3000, 0.0);
	}
	void draw1() {
		glPushMatrix();
		glTranslatef(-400*100.0 + 0*100, -400*100.0, 0.0);
		glScalef( 0.075 * 10, 0.15 * 10, 0.2  * 10);
		drawScore(allTime);
		drawScore(fastestTime);
		for (int i = 0; i < lapTimes.length; i++) {
			if(lapTimes[(i+lap) % $] != 0)drawScore(lapTimes[(i+lap) % $]);
		}
		drawScore(lapTime);
		glPopMatrix();
	}
}
