private import std.file;
private import std.process;
private import std.string;
private import std.path;
private import std.stream;

void main() {
	mktable();
	char[] libs = "";
	foreach (char[] lib; listdir("lib")) {
		libs = libs ~ " ../lib/" ~ lib;
	}
	char[] str =
		"dmd -I../import -of.."~sep~"generators -release -O ../import/SDL_mixer.obj Kernel32.lib"
		~ std.string.join(listdir("src"), " ").replace(" .","").replace(" ..","") ~ libs;
	rmdata();
	chdir("src");
	rmdata();
	printf("%.*s\n", str);
	int rc = system(str);
	rmdata();
	chdir("..");
	rmdata();
	if (rc == 0) {
		system("generators");
	}
}

void rmdata() {
	foreach(char[] name; listdir(".")) {
		if (getExt(name) == "obj" || getExt(name) == "map") {
			remove(name);
		}
	}
}

void mktable() {
	char[] files = "";
	auto File file = new File("out.txt", FileMode.Out);
	file.printf("import all;\nenum{\n");
	foreach (char[] name; listdir("char")) {
		printf ("%.*s,\n", name.split(".")[0]);
		file.printf("\t%.*s,\n", name.split(".")[0].toupper());
	}
	file.printf("\tMAX_CHAR,\n");
	file.printf("}\n");
	file.printf("static this() {\n");
	file.printf("\tpdrs.length = MAX_CHAR;\n");
	foreach (char[] name; listdir("char")) {
		file.printf("\tpdrs[%.*s] = getChar(\"%.*s\", dir);\n", 
			name.split(".")[0].toupper(), name);
	}
	file.printf("}\n");
	file.close();
}
