private import all;

class Ship: TaskObject {
	mixin GROUP!(GROUP_SHIP);

	static Ship shipData;
	int oldno;
	int state;
	float bank;
	enum {DRIFT,GRIP};
	
	static Ship ship() {
		return shipData;
	}

	this() {
		shipData = this;

		size = 16 * 500000;
		energy = 30;
		direction = 0;
		vX = vY = 0;
		move = &move1;
//		draw = &defaultDraw;
		draw = &draw1;
		state = DRIFT;
		pos = int.max;
	}
	int pos;
	int gripcnt;
	void move1() {
		if (!Game.gameData.pause) {
			float a = 180;
			float ax = 0;
			float ay = 0;
			float gx = 0;
			float gy = 0;
			float v = sqrt(vX*vX+vY*vY);
			float x1;
			float y1;
			float keyno = 0;
			float add = 1;
			float trg1 = 0;
//			state=DRIFT;
			if (state==DRIFT) {
				a = 50;
				add = 3;
			}
			if (pads & PAD_LEFT   ) keyno += add;
			if (pads & PAD_RIGHT  ) keyno -= add;
			if (trgs & PAD_BUTTON1) {
				if(keyno != 0) { state = DRIFT; gripcnt = 0; }
				else           { trg1 += 15;  gripcnt+=25;} 
			}
			if (!(pads & PAD_BUTTON1)) gripcnt+=5;
			direction = direction + keyno;
			if (pads & PAD_BUTTON1) {
				ax = a * -sin(direction*PI/180);
				ay = a * -cos(direction*PI/180);
			}
			gx = v * -sin(direction*PI/180) + ax;
			gy = v * -cos(direction*PI/180) + ay;
			float dx = vX + ax;// * (1.0 + Camera.z/ 70000);
			float dy = vY + ay;// * (1.0 + Camera.z/ 70000);
			if (state==DRIFT) {
				x1 = (dx*40 + gx) / 41;
				y1 = (dy*40 + gy) / 41;
			} else {
				x1 = gx;
				y1 = gy;
			}
			float px = x + x1, py = y + y1;
			int no = Course.check(px, py);
			pos = Course.getRank(x,y);
			if (no == 0) {
				state = DRIFT;
				gripcnt = 0;
				float px2, py2;
				Course.checkNo(oldno, x, y, px, py, px2, py2);
//				printf("%4.0f %4.0f\n", px2, py2);
				x1 = px - x;
				y1 = py - y;
//				x = px; y = py;
//				vX = x1 * 0.2;
//				vY = y1 * 0.2;
//				return;
			} else {
				oldno = no;
				x = px; y = py;
			}
			float f = (x1*x1+y1*y1)*0.0000000005;
			vX = x1 * (1-f);
			vY = y1 * (1-f);
			V a1 = V(-sin(direction*PI/180), -cos(direction*PI/180));
			V a2 = V(vX,vY);
			float a3 = a1 * a2;
//			printf("%08f\n", std.math.abs(a3));
			bank = a3;
			if (std.math.abs(a3) < 1500) gripcnt+=2;
			else gripcnt = 0;
			if (gripcnt > 30) state = GRIP;
			
		}
		
	}
	void draw1() {
		glPushMatrix();
		glTranslatef(x, y, 0);
		glRotatef(direction, 0, 0, -1);
		glTranslatef(0, 0, -100);
		pdr.draw("Ship2.pdr");
		glTranslatef(0, 0, 300);
		pdr.draw("Ship1.pdr");
		glTranslatef(0, 0, 300);
		pdr.draw("Ship1.pdr");
		glTranslatef(0, 0, 300);
		pdr.draw("Ship0.pdr");
		glPopMatrix();
	}

}
